/**************************************************/
/***                                            ***/
/*** TEST.c  -- test interface to inpout32.dll  ***/
/***  ( http://www.logix4u.net/inpout32.htm )   ***/
/***                                            ***/
/*** Copyright (C) 2003, Douglas Beattie Jr.    ***/
/***                                            ***/
/***    <beattidp@ieee.org>                     ***/
/***    http://www.hytherion.com/beattidp/      ***/
/***                                            ***/
/**************************************************/
/*******************************************************/
/*                                                     */
/*  Builds with Borland's Command-line C Compiler      */
/*    (free for public download from Borland.com, at   */
/*  http://www.borland.com/bcppbuilder/freecompiler )  */
/*                                                     */
/*   Compile with:                                     */
/*                                                     */
/*   BCC32 -IC:\BORLAND\BCC55\INCLUDE  TEST.C          */
/*                                                     */
/*                                                     */
/*  Be sure to change the Port addresses               */
/*  accordingly if your LPT port is addressed          */
/*  elsewhere.                                         */
/*                                                     */
/*******************************************************/
//---------------------------------------------------------------------------
// Modifiziert von Fabian Braun EL6A April-Juni 2004
//---------------------------------------------------------------------------
#include <stdio.h>
#include <conio.h>
#include <windows.h>

/* Definitions in the build of inpout32.dll are:            */
/*   short _stdcall Inp32(short PortAddress);               */
/*   void _stdcall Out32(short PortAddress, short data);    */
   
/* prototype (function typedef) for DLL function Inp32: */
typedef short _stdcall (*inpfuncPtr)(short portaddr);
typedef void _stdcall (*oupfuncPtr)(short portaddr, short datum);
inpfuncPtr inp32;
oupfuncPtr oup32;

// Prototyping
//---------------------------------------------------------------------------
short inp(short addr);
void outp(short addr, short data);
void set_bit(short addr, short byte);
void clear_bit(short addr, short byte);
int dll(int load);

// Byte einlesen
//---------------------------------------------------------------------------
short inp(short addr)
{
   return (inp32)(addr);
}

// Byte ausgeben
//---------------------------------------------------------------------------
void outp(short addr, short data)
{
   (oup32)(addr,data);
}

// Bit setzen
//---------------------------------------------------------------------------
void set_bit(short addr, short bit)
{
   short z;                            //Temporrer Speicher

   z = inp(addr);                      //Aktueller Portstatus einlesen
   z = z | (0x01 << bit);              //Entsprechendes Bit setzen
   outp(addr, z);                      //Neuer Wert ausgeben
}

// Bit lschen
//---------------------------------------------------------------------------
void clear_bit(short addr, short bit)
{
   short z;                            //Temporrer Speicher

   z = inp(addr);                      //Aktueller Portstatus einlesen
   z = z & ~(0x01 << bit);             //Entsprechendes Bit lschen
   outp(addr, z);                      //Neuer Wert ausgeben
}

// DLL Initialisierung bzw. desinitialisierung
//
// (load == 1) DLL laden und Funktionen definieren
// (load == 0) DLL entladen
//---------------------------------------------------------------------------
int dll(int load)
{
   HINSTANCE hLib;                     //DLL-Objekt

   if (load == 1)
   //DLL laden und Funktionen definieren
   {
      /* Load the library */
      hLib = LoadLibrary("inpout32.dll");

      if (hLib == NULL)
      {
         //printf("LoadLibrary Failed.\n");
         return 0;                     //Fehlgeschlagen
      }

      /* get the address of the function */
      inp32 = (inpfuncPtr) GetProcAddress(hLib, "Inp32");

      if (inp32 == NULL)
      {
         //printf("GetProcAddress for Inp32 Failed.\n");
         return 0;                     //Fehlgeschlagen
      }

      /* get the address of the 2nd function */
      oup32 = (oupfuncPtr) GetProcAddress(hLib, "Out32");

      if (oup32 == NULL)
      {
         //printf("GetProcAddress for Oup32 Failed.\n");
         return 0;                     //Fehlgeschlagen
      }

      return 1;                        //DLL erfolgreich geladen
   }
   else
   //DLL entladen
   {
      FreeLibrary(hLib);               //Bibliothek entladen
      return 1;                        //DLL erfolgreich entladen
   }
}

